xref: /openbmc/linux/scripts/link-vmlinux.sh (revision b9f0bfd1)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41	printf "  %-7s %s\n" "${1}" "${2}"
42}
43
44# Generate a linker script to ensure correct ordering of initcalls.
45gen_initcalls()
46{
47	info GEN .tmp_initcalls.lds
48
49	${PYTHON} ${srctree}/scripts/jobserver-exec		\
50	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
51		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
52		> .tmp_initcalls.lds
53}
54
55# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56# .tmp_symversions.lds
57gen_symversions()
58{
59	info GEN .tmp_symversions.lds
60	rm -f .tmp_symversions.lds
61
62	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63		if [ -f ${o}.symversions ]; then
64			cat ${o}.symversions >> .tmp_symversions.lds
65		fi
66	done
67}
68
69# Link of vmlinux.o used for section mismatch analysis
70# ${1} output file
71modpost_link()
72{
73	local objects
74	local lds=""
75
76	objects="--whole-archive				\
77		${KBUILD_VMLINUX_OBJS}				\
78		--no-whole-archive				\
79		--start-group					\
80		${KBUILD_VMLINUX_LIBS}				\
81		--end-group"
82
83	if [ -n "${CONFIG_LTO_CLANG}" ]; then
84		gen_initcalls
85		lds="-T .tmp_initcalls.lds"
86
87		if [ -n "${CONFIG_MODVERSIONS}" ]; then
88			gen_symversions
89			lds="${lds} -T .tmp_symversions.lds"
90		fi
91
92		# This might take a while, so indicate that we're doing
93		# an LTO link
94		info LTO ${1}
95	else
96		info LD ${1}
97	fi
98
99	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
100}
101
102objtool_link()
103{
104	local objtoolcmd;
105	local objtoolopt;
106
107	if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108		# Don't perform vmlinux validation unless explicitly requested,
109		# but run objtool on vmlinux.o now that we have an object file.
110		if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111			objtoolcmd="orc generate"
112		fi
113
114		objtoolopt="${objtoolopt} --duplicate"
115
116		if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117			objtoolopt="${objtoolopt} --mcount"
118		fi
119	fi
120
121	if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
122		objtoolopt="${objtoolopt} --noinstr"
123	fi
124
125	if [ -n "${objtoolopt}" ]; then
126		if [ -z "${objtoolcmd}" ]; then
127			objtoolcmd="check"
128		fi
129		objtoolopt="${objtoolopt} --vmlinux"
130		if [ -z "${CONFIG_FRAME_POINTER}" ]; then
131			objtoolopt="${objtoolopt} --no-fp"
132		fi
133		if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
134			objtoolopt="${objtoolopt} --no-unreachable"
135		fi
136		if [ -n "${CONFIG_RETPOLINE}" ]; then
137			objtoolopt="${objtoolopt} --retpoline"
138		fi
139		if [ -n "${CONFIG_X86_SMAP}" ]; then
140			objtoolopt="${objtoolopt} --uaccess"
141		fi
142		info OBJTOOL ${1}
143		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
144	fi
145}
146
147# Link of vmlinux
148# ${1} - output file
149# ${2}, ${3}, ... - optional extra .o files
150vmlinux_link()
151{
152	local output=${1}
153	local objs
154	local libs
155	local ld
156	local ldflags
157	local ldlibs
158
159	info LD ${output}
160
161	# skip output file argument
162	shift
163
164	if [ -n "${CONFIG_LTO_CLANG}" ]; then
165		# Use vmlinux.o instead of performing the slow LTO link again.
166		objs=vmlinux.o
167		libs=
168	else
169		objs="${KBUILD_VMLINUX_OBJS}"
170		libs="${KBUILD_VMLINUX_LIBS}"
171	fi
172
173	if [ "${SRCARCH}" = "um" ]; then
174		wl=-Wl,
175		ld="${CC}"
176		ldflags="${CFLAGS_vmlinux}"
177		ldlibs="-lutil -lrt -lpthread"
178	else
179		wl=
180		ld="${LD}"
181		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
182		ldlibs=
183	fi
184
185	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
186
187	# The kallsyms linking does not need debug symbols included.
188	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
189		ldflags="${ldflags} ${wl}--strip-debug"
190	fi
191
192	if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
193		ldflags="${ldflags} ${wl}-Map=${output}.map"
194	fi
195
196	${ld} ${ldflags} -o ${output}					\
197		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
198		${wl}--start-group ${libs} ${wl}--end-group		\
199		$@ ${ldlibs}
200}
201
202# generate .BTF typeinfo from DWARF debuginfo
203# ${1} - vmlinux image
204# ${2} - file to dump raw BTF data into
205gen_btf()
206{
207	local pahole_ver
208
209	if ! [ -x "$(command -v ${PAHOLE})" ]; then
210		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
211		return 1
212	fi
213
214	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
215	if [ "${pahole_ver}" -lt "116" ]; then
216		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
217		return 1
218	fi
219
220	vmlinux_link ${1}
221
222	info "BTF" ${2}
223	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
224
225	# Create ${2} which contains just .BTF section but no symbols. Add
226	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
227	# deletes all symbols including __start_BTF and __stop_BTF, which will
228	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
229	# objcopy warnings: "empty loadable segment detected at ..."
230	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
231		--strip-all ${1} ${2} 2>/dev/null
232	# Change e_type to ET_REL so that it can be used to link final vmlinux.
233	# Unlike GNU ld, lld does not allow an ET_EXEC input.
234	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
235}
236
237# Create ${2} .S file with all symbols from the ${1} object file
238kallsyms()
239{
240	local kallsymopt;
241
242	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
243		kallsymopt="${kallsymopt} --all-symbols"
244	fi
245
246	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
247		kallsymopt="${kallsymopt} --absolute-percpu"
248	fi
249
250	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
251		kallsymopt="${kallsymopt} --base-relative"
252	fi
253
254	info KSYMS ${2}
255	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
256}
257
258# Perform one step in kallsyms generation, including temporary linking of
259# vmlinux.
260kallsyms_step()
261{
262	kallsymso_prev=${kallsymso}
263	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
264	kallsymso=${kallsyms_vmlinux}.o
265	kallsyms_S=${kallsyms_vmlinux}.S
266
267	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
268	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
269
270	info AS ${kallsyms_S}
271	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
272	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
273	      -c -o ${kallsymso} ${kallsyms_S}
274}
275
276# Create map file with all symbols from ${1}
277# See mksymap for additional details
278mksysmap()
279{
280	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
281}
282
283sorttable()
284{
285	${objtree}/scripts/sorttable ${1}
286}
287
288# Delete output files in case of error
289cleanup()
290{
291	rm -f .btf.*
292	rm -f .tmp_System.map
293	rm -f .tmp_initcalls.lds
294	rm -f .tmp_symversions.lds
295	rm -f .tmp_vmlinux*
296	rm -f System.map
297	rm -f vmlinux
298	rm -f vmlinux.map
299	rm -f vmlinux.o
300	rm -f .vmlinux.d
301}
302
303# Use "make V=1" to debug this script
304case "${KBUILD_VERBOSE}" in
305*1*)
306	set -x
307	;;
308esac
309
310if [ "$1" = "clean" ]; then
311	cleanup
312	exit 0
313fi
314
315# We need access to CONFIG_ symbols
316. include/config/auto.conf
317
318# Update version
319info GEN .version
320if [ -r .version ]; then
321	VERSION=$(expr 0$(cat .version) + 1)
322	echo $VERSION > .version
323else
324	rm -f .version
325	echo 1 > .version
326fi;
327
328# final build of init/
329${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
330
331#link vmlinux.o
332modpost_link vmlinux.o
333objtool_link vmlinux.o
334
335# modpost vmlinux.o to check for section mismatches
336${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
337
338info MODINFO modules.builtin.modinfo
339${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
340info GEN modules.builtin
341# The second line aids cases where multiple modules share the same object.
342tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
343	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
344
345btf_vmlinux_bin_o=""
346if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
347	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
348	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
349		echo >&2 "Failed to generate BTF for vmlinux"
350		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
351		exit 1
352	fi
353fi
354
355kallsymso=""
356kallsymso_prev=""
357kallsyms_vmlinux=""
358if [ -n "${CONFIG_KALLSYMS}" ]; then
359
360	# kallsyms support
361	# Generate section listing all symbols and add it into vmlinux
362	# It's a three step process:
363	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
364	#     but __kallsyms is empty.
365	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
366	#     the right size
367	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
368	#     the right size, but due to the added section, some
369	#     addresses have shifted.
370	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
371	# 3)  That link may have expanded the kernel image enough that
372	#     more linker branch stubs / trampolines had to be added, which
373	#     introduces new names, which further expands kallsyms. Do another
374	#     pass if that is the case. In theory it's possible this results
375	#     in even more stubs, but unlikely.
376	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
377	#     other bugs.
378	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
379	#
380	# a)  Verify that the System.map from vmlinux matches the map from
381	#     ${kallsymso}.
382
383	kallsyms_step 1
384	kallsyms_step 2
385
386	# step 3
387	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
388	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
389
390	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
391		kallsyms_step 3
392	fi
393fi
394
395vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
396
397# fill in BTF IDs
398if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
399	info BTFIDS vmlinux
400	${RESOLVE_BTFIDS} vmlinux
401fi
402
403if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
404	info SORTTAB vmlinux
405	if ! sorttable vmlinux; then
406		echo >&2 Failed to sort kernel tables
407		exit 1
408	fi
409fi
410
411info SYSMAP System.map
412mksysmap vmlinux System.map
413
414# step a (see comment above)
415if [ -n "${CONFIG_KALLSYMS}" ]; then
416	mksysmap ${kallsyms_vmlinux} .tmp_System.map
417
418	if ! cmp -s System.map .tmp_System.map; then
419		echo >&2 Inconsistent kallsyms data
420		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
421		exit 1
422	fi
423fi
424
425# For fixdep
426echo "vmlinux: $0" > .vmlinux.d
427